package learning

import "fmt"

func TypeAssertionLearning() {
  // Declaring i variable with empty interface and containing "Hello" string
  var i interface{} = "Hello"
  // Type asserting interface i with string type
  s := i.(string)
  // Since type assertion returns underlying string value, this will print "Hello"
  fmt.Println(s)

  // Type assertion can return second boolean value, that will tell if type is correct
  s, ok := i.(string)
  fmt.Println(s, ok)
  
  // If assertion is false - then ok will be false and f will be zero value of type
  f, ok := i.(float64)
  fmt.Println(f, ok)
  
  // If assertion returns false and not second arg provided - panic will be triggered
  // f = i.(float64)
  // fmt.Println(f)
}

func do(i interface{}) {
	switch v := i.(type) {
	case int:
		fmt.Printf("Twice %v is %v\n", v, v*2)
	case string:
		fmt.Printf("%q is %v bytes long\n", v, len(v))
	default:
		fmt.Printf("I don't know about type %T!\n", v)
	}
}

func TypeSwitchLearnings() {
  do(21)
  do("hello")
  do(true)
}
